VERSION 8000;;8415
* Bahn_VermarkungsartAendern.CSX  Vermarkungsart aus Punktkode ableiten  08.01.13
* -----------------------------------------------------------------------------
* @filedoc
* @file Bahn_VermarkungsartAendern.CSX
* @brief Vermarkungsart aus Punktkode ableiten 
* 
* <Mit diesem Skript ordnen Sie ausgewhlten Punkten eine neue Vermarkungsart zu.
*  Auswhlen lassen sich Punkte ber die Markierung oder einen Kodebereich.
*  Die Zuordnung einer Vermarkungsart erfolgt ber den Punktkode. >
*
* -----------------------------------------------------------------------------
* Copyright (C) IB&T
* 
* Gewhrleistung und Nutzung
* 
* Die Nutzung des Skriptes erfolgt stets auf eigene Gefahr. IB&T bernimmt keine
* Gewhr dafr, dass die Nutzung dieses Skriptes zu Ihrem gewnschten Ergebnis
* fhrt. Da CardScripte vorhandene Projektdaten durch Direktzugriff auf die
* jeweiligen Datenbanken auch ohne weitere Sicherheitsabfragen unbemerkt verndern
* oder lschen knnen, erfordert eine Nutzung entsprechende Kenntnisse und groe
* Sorgfalt. IB&T haftet nicht fr eventuell entstehende Datenverluste und
* Folgeschden, die durch die Nutzung von CardScripten entstehen.
*
* -----------------------------------------------------------------------------
* @author CK
* @endfiledoc
* -----------------------------------------------------------------------------
* @history
* -----------------------------------------------------------------------------
$CHECKLEVEL 7
* 
BILDSCHIRM GRAFIK
*
* Variablen-Deklaration -------------------------------------------
SYMBOLE /POINTSYS/        PointSys           | Variable fr System der Punkte
SYMBOLE /POINT/           Point              | Variable fr Punkt aus der Punktdatenbank
SYMBOLE /POINTINDEX/      PointIndex         | Variable fr Punktindexobjekt
*
* Variablen-Deklaration fr Dialog 
SYMBOLE /DLG_WINDOW/      Dialog             | Variable fr den Dialog
SYMBOLE /DLG_FRAME/       Rahmen1;Rahmen2    | Dialog - Rahmen
SYMBOLE /DLG_COMBOBOX/    DF_Combo1          | Comboboxfeld
SYMBOLE /MY_BUTTON/       DF_BUMark          | Button zum Wechsel in die Grafik
SYMBOLE /DLG_CODEPOINT/   DF_PKodeVonAusw;DF_PKodeBisAusw            | Dialogfelder fr Punktkodes
SYMBOLE /DLG_CODEPOINT/   DF_PKodeVon1;DF_PKodeBis1;DF_PKodeVon2;DF_PKodeBis2;DF_PKodeVon3;DF_PKodeBis3;DF_PKodeVon4;DF_PKodeBis4;DF_PKodeVon5;DF_PKodeBis5
SYMBOLE /DLG_NUMBER/      DF_VArt1;DF_VArt2;DF_VArt3;DF_VArt4;DF_VArt5 | Wertfelder
* Variablen-Deklaration fr den Rest 
SYMBOLE * Ret; Mark; PKode; PKodeVon;PKodeBis; PKodeVon1;PKodeBis1; PKodeVon2;PKodeBis2; PKodeVon3;PKodeBis3; PKodeVon4;PKodeBis4; PKodeVon5;PKodeBis5
SYMBOLE * VArt1; VArt2; VArt3; VArt4; VArt5; VArtMin; VArtMax; IPtMarked; IPtKode0; IPtPosProtected; PosProtection
SYMBOLE * IPtVArt1; IPtVArt2; IPtVArt3; IPtVArt4; IPtVArt5

* Vorschlagswerte fr Dialog
Mark  = 1            | Schalter fr Combobox "Auswahl ber"
PKodeVon = 0         | auszuwertender Punktkode 
PKodeBis = 0         | auszuwertender Punktkode
VArt1 = 1
VArt2 = 2
VArt3 = 3
VArt4 = 4
VArt5 = 5

NEUSYMBOLE 0
EINSYMBOLE "VermArtEingabe.QPS"                           | lesen der Eingaben aus VermArtEingabe.QPS
*
* Grenzen
VArtMax = 255
VArtMin = 0
* Dialog malen und Anwendereingaben kontrolliert auswerten
Dialog = NEWOBJECT /DLG_WINDOW/
Dialog.SetCaption("Vermarkungsart ber Punktkode zuordnen") 
Rahmen1 = Dialog.CreateFrame(0;"Punkte")            | 
Rahmen1.SetSize(105) 
Rahmen2 = Dialog.CreateFrame(0;"Zuordnungstabelle")
Rahmen2.SetSize(105) 

*Dialogfelder
* Auswahl ber ...
DF_Combo1 = NewObject /DLG_COMBOBOX/
DF_Combo1.SetLabel("Auswahl ber:")
DF_Combo1.AddText("Markierte Punkte ";1)
DF_Combo1.AddText("Kodebereich";2)
DF_Combo1.SetSize(30)
DF_Combo1.SetValue(Mark)
Rahmen1.AddField(DF_Combo1)
* Button zum "Zeigen-Men" 
DF_BUMark = NewObject /MY_BUTTON/
DF_BUMark.SetCaption("Grafik...")
DF_BUMark.SetId(9001)                   
DF_BUMark.AppendRight()
Rahmen1.AddField(DF_BUMark)
* Punktkode von ...
DF_PKodeVonAusw = NewObject /DLG_CODEPOINT/
DF_PKodeVonAusw.SetLabel("Kodebereich von:")
DF_PKodeVonAusw.SetCode(PKodeVon)
DF_PKodeVonAusw.AddObserveField(DF_Combo1;1;2;2)
DF_PKodeVonAusw.DisableDescription()
Rahmen1.AddField(DF_PKodeVonAusw)
* ... bis Punktkode
DF_PKodeBisAusw = NewObject /DLG_CODEPOINT/
DF_PKodeBisAusw.SetLabel("     bis:")
DF_PKodeBisAusw.SetCode(PKodeBis)
DF_PKodeBisAusw.AppendRight()
DF_PKodeBisAusw.AddObserveField(DF_Combo1;1;2;2)
DF_PKodeBisAusw.DisableDescription()
Rahmen1.AddField(DF_PKodeBisAusw)
* Zuordnungstabellen
* Kodebereich 1  --> Vermarkungsart 1
DF_PKodeVon1 = NewObject /DLG_CODEPOINT/
DF_PKodeVon1.SetLabel("Kodebereich von:")
DF_PKodeVon1.SetCode(PKodeVon1)
DF_PKodeVon1.DisableDescription()
Rahmen2.AddField(DF_PKodeVon1)
DF_PKodeBis1 = NewObject /DLG_CODEPOINT/
DF_PKodeBis1.SetLabel("     bis:")
DF_PKodeBis1.SetCode(PKodeBis1)
DF_PKodeBis1.AppendRight()
DF_PKodeBis1.DisableDescription()
Rahmen2.AddField(DF_PKodeBis1)
DF_VArt1 = NewObject /DLG_NUMBER/
DF_VArt1.SetLabel("   Vermarkungsart:")
DF_VArt1.SetSize(6)
DF_VArt1.SetValue(VArt1)
DF_VArt1.SetMinValue(VArtMin)
DF_VArt1.SetMaxValue(VArtMax)
DF_VArt1.AppendRight()
Rahmen2.AddField(DF_VArt1)
* Kodebereich 2  --> Vermarkungsart 2
DF_PKodeVon2 = NewObject /DLG_CODEPOINT/
DF_PKodeVon2.SetLabel("Kodebereich von:")
DF_PKodeVon2.SetCode(PKodeVon2)
DF_PKodeVon2.DisableDescription()
Rahmen2.AddField(DF_PKodeVon2)
DF_PKodeBis2 = NewObject /DLG_CODEPOINT/
DF_PKodeBis2.SetLabel("     bis:")
DF_PKodeBis2.SetCode(PKodeBis2)
DF_PKodeBis2.AppendRight()
DF_PKodeBis2.DisableDescription()
Rahmen2.AddField(DF_PKodeBis2)
DF_VArt2 = NewObject /DLG_NUMBER/
DF_VArt2.SetLabel("   Vermarkungsart:")
DF_VArt2.SetSize(6)
DF_VArt2.SetValue(VArt2)
DF_VArt2.SetMinValue(VArtMin)
DF_VArt2.SetMaxValue(VArtMax)
DF_VArt2.AppendRight()
Rahmen2.AddField(DF_VArt2)
* Kodebereich 3  --> Vermarkungsart 3
DF_PKodeVon3 = NewObject /DLG_CODEPOINT/
DF_PKodeVon3.SetLabel("Kodebereich von:")
DF_PKodeVon3.SetCode(PKodeVon3)
DF_PKodeVon3.DisableDescription()
Rahmen2.AddField(DF_PKodeVon3)
DF_PKodeBis3 = NewObject /DLG_CODEPOINT/
DF_PKodeBis3.SetLabel("     bis:")
DF_PKodeBis3.SetCode(PKodeBis3)
DF_PKodeBis3.AppendRight()
DF_PKodeBis3.DisableDescription()
Rahmen2.AddField(DF_PKodeBis3)
DF_VArt3 = NewObject /DLG_NUMBER/
DF_VArt3.SetLabel("   Vermarkungsart:")
DF_VArt3.SetSize(6)
DF_VArt3.SetValue(VArt3)
DF_VArt3.SetMinValue(VArtMin)
DF_VArt3.SetMaxValue(VArtMax)
DF_VArt3.AppendRight()
Rahmen2.AddField(DF_VArt3)
* Kodebereich 4  --> Vermarkungsart 4
DF_PKodeVon4 = NewObject /DLG_CODEPOINT/
DF_PKodeVon4.SetLabel("Kodebereich von:")
DF_PKodeVon4.SetCode(PKodeVon4)
DF_PKodeVon4.DisableDescription()
Rahmen2.AddField(DF_PKodeVon4)
DF_PKodeBis4 = NewObject /DLG_CODEPOINT/
DF_PKodeBis4.SetLabel("     bis:")
DF_PKodeBis4.SetCode(PKodeBis4)
DF_PKodeBis4.AppendRight()
DF_PKodeBis4.DisableDescription()
Rahmen2.AddField(DF_PKodeBis4)
DF_VArt4 = NewObject /DLG_NUMBER/
DF_VArt4.SetLabel("   Vermarkungsart:")
DF_VArt4.SetSize(6)
DF_VArt4.SetValue(VArt4)
DF_VArt4.SetMinValue(VArtMin)
DF_VArt4.SetMaxValue(VArtMax)
DF_VArt4.AppendRight()
Rahmen2.AddField(DF_VArt4)
* Kodebereich 5  --> Vermarkungsart 5
DF_PKodeVon5 = NewObject /DLG_CODEPOINT/
DF_PKodeVon5.SetLabel("Kodebereich von:")
DF_PKodeVon5.SetCode(PKodeVon5)
DF_PKodeVon5.DisableDescription()
Rahmen2.AddField(DF_PKodeVon5)
DF_PKodeBis5 = NewObject /DLG_CODEPOINT/
DF_PKodeBis5.SetLabel("     bis:")
DF_PKodeBis5.SetCode(PKodeBis5)
DF_PKodeBis5.AppendRight()
DF_PKodeBis5.DisableDescription()
Rahmen2.AddField(DF_PKodeBis5)
DF_VArt5 = NewObject /DLG_NUMBER/
DF_VArt5.SetLabel("   Vermarkungsart:")
DF_VArt5.SetSize(6)
DF_VArt5.SetValue(VArt5)
DF_VArt5.SetMinValue(VArtMin)
DF_VArt5.SetMaxValue(VArtMax)
DF_VArt5.AppendRight()
Rahmen2.AddField(DF_VArt5)

* Dialog ausfhren
Ret = Dialog.DoDialog()
IF Ret THEN
  Mark = DF_Combo1.GetValue()
  PKodeVon = DF_PKodeVonAusw.GetCode()
  PKodeBis = DF_PKodeBisAusw.GetCode()

  PKodeVon1 = DF_PKodeVon1.GetCode()
  PKodeBis1 = DF_PKodeBis1.GetCode()
      VArt1 = DF_VArt1.GetValue()

  PKodeVon2 = DF_PKodeVon2.GetCode()
  PKodeBis2 = DF_PKodeBis2.GetCode()
      VArt2 = DF_VArt2.GetValue()

  PKodeVon3 = DF_PKodeVon3.GetCode()
  PKodeBis3 = DF_PKodeBis3.GetCode()
      VArt3 = DF_VArt3.GetValue()

  PKodeVon4 = DF_PKodeVon4.GetCode()
  PKodeBis4 = DF_PKodeBis4.GetCode()
      VArt4 = DF_VArt4.GetValue()

  PKodeVon5 = DF_PKodeVon5.GetCode()
  PKodeBis5 = DF_PKodeBis5.GetCode()
      VArt5 = DF_VArt5.GetValue()
ELSE 
  STOP
END IF
AUSSYMBOLE Mark;PKodeVon;PKodeBis
AUSSYMBOLE PKodeVon1;PKodeBis1; PKodeVon2;PKodeBis2; PKodeVon3;PKodeBis3; PKodeVon4;PKodeBis4; PKodeVon5;PKodeBis5
AUSSYMBOLE VArt1; VArt2; VArt3; VArt4; VArt5

*
* Zugriff auf die gewnschten Punkte vorbereiten
PointSys = Project.GetPointSys()                   | liefert das Objekt fr das System der Punkte
PointIndex = PointSys.GetPointIndex(1)             | liefert das Punktindexobjekt 
IF Mark==1 THEN
  PointIndex.SetMarkFilter(1)                      | Filter: markierte Punkte
ELSE
  PointIndex.SetCodeFilter(PKodeVon;PKodeBis)    | Filter: Punkte ber Kodebereich
END IF
* Zhlvariablen
IPtMarked  = 0          | Ausgewhlte Punkte
IPtKode0   = 0          | Ausgewhlte Punkte mit Kode 0
IPtPosProtected   = 0   | Ausgewhlte Punkte mit Lageschutz, die nicht den Kode 0 besitzen
IPtVArt1  = 0           | Punkte, die auf Vermarkungsart 1 gesetzt wurden 
IPtVArt2  = 0           | Punkte, die auf Vermarkungsart 2 gesetzt wurden 
IPtVArt3  = 0           | Punkte, die auf Vermarkungsart 3 gesetzt wurden 
IPtVArt4  = 0           | Punkte, die auf Vermarkungsart 4 gesetzt wurden 
IPtVArt5  = 0           | Punkte, die auf Vermarkungsart 5 gesetzt wurden 

* Schleife ber die gefilterten Punkte
WHILE  Point = PointIndex.GetNext()        | liefert nchten Punkt
  IPtMarked = IPtMarked + 1
  PKode = Point.GetCode()
  PosProtection = Point.GetPosProtection()
  IF PKode==0 THEN
    IPtKode0 = IPtKode0 + 1
    NEXT WHILE
  END IF
  IF PosProtection==1 THEN
    IPtPosProtected = IPtPosProtected + 1
    NEXT WHILE
  END IF
  IF      PKodeVon1 <= PKode & PKode <= PKodeBis1 THEN 
    Point.SetMarkerType(VArt1)
    IPtVArt1 = IPtVArt1 + 1
  ELSE IF PKodeVon2 <= PKode & PKode <= PKodeBis2 THEN 
    Point.SetMarkerType(VArt2)
    IPtVArt2 = IPtVArt2 + 1
  ELSE IF PKodeVon3 <= PKode & PKode <= PKodeBis3 THEN 
    Point.SetMarkerType(VArt3)
    IPtVArt3 = IPtVArt3 + 1
  ELSE IF PKodeVon4 <= PKode & PKode <= PKodeBis4 THEN 
    Point.SetMarkerType(VArt4)
    IPtVArt4 = IPtVArt4 + 1
  ELSE IF PKodeVon5 <= PKode & PKode <= PKodeBis5 THEN 
    Point.SetMarkerType(VArt5)
    IPtVArt5 = IPtVArt5 + 1
  END IF 
END WHILE                  | Ende der Schleife ber die Punkte
REPORT " Vermarkungsart von Punkten anhand des Punktkodes setzen"
REPORT " "
REPORT " Ausgewhlte Punkte:      ###### "; IPtMarked 
REPORT " Punkte mit Kode 0:       ###### (diese werden bersprungen)"; IPtKode0
REPORT " Punkte mit Lageschutz:   ###### (diese werden nicht gendert)"; IPtPosProtected
REPORT " -------------------------------------------------------------------------"
REPORT " 1. Kodebereich (####/####) auf Vermarkungsart ### gesetzt:  ###### Punkte"; PKodeVon1;PKodeBis1;VArt1;IPtVArt1
REPORT " 2. Kodebereich (####/####) auf Vermarkungsart ### gesetzt:  ###### Punkte"; PKodeVon2;PKodeBis2;VArt2;IPtVArt2
REPORT " 3. Kodebereich (####/####) auf Vermarkungsart ### gesetzt:  ###### Punkte"; PKodeVon3;PKodeBis3;VArt3;IPtVArt3
REPORT " 4. Kodebereich (####/####) auf Vermarkungsart ### gesetzt:  ###### Punkte"; PKodeVon4;PKodeBis4;VArt4;IPtVArt4
REPORT " 5. Kodebereich (####/####) auf Vermarkungsart ### gesetzt:  ###### Punkte"; PKodeVon5;PKodeBis5;VArt5;IPtVArt5
REPORT " ========================================================================= "

* -----------------------------------------------------------------------------
* @class /MY_BUTTON/
* @brief <Klasse fr den Dialog-Button zum Wechsel in die Grafik(zeigen-Men)>
* @ingroup
* @author CK
* @endclass
CLASS /MY_BUTTON/; /DLG_BUTTON/

* -------------------------------------------------------------------
  FUNCTION {long} Push:
   EXTERN /DLG_WINDOW/      Dialog             | Variable fr den Dialog
   SELECT GetId()
    CASE 9001 
       Dialog.ShowShowMenu()           
    END SELECT 
  END FUNCTION 
* -------------------------------------------------------------------

END CLASS

